//
//  ERApplet+QCC5100Sample.swift
//  qcc5100.sample
//

import RiiiverSDK

extension ERApplet: Identifiable {
}

extension ERApplet {
    var isSampleTrigger: Bool {
        return self.getBlock(.triggerBlock).metaData.executor == TriggerPieceCoreSample.className
    }
    
    var isQCC5100Trigger: Bool {
        return self.getBlock(.triggerBlock).metaData.executor == QCC5100TriggerPieceCore.className
    }
    
    var isActivated: Bool {
        get async {
            let (isActivated, error) = await self.getActivateStatus()
            guard error == nil else { return false }
            return isActivated
        }
    }
}

extension [ERApplet] {
    var kickedByQCC5100Applets: [ERApplet] {
        return self.filter { $0.isQCC5100Trigger }
    }
    
    var activatedApplets: [ERApplet] {
        get async throws {
            await withTaskGroup(of: (ERApplet, Bool).self) { group in
                for applet in self {
                    group.addTask { await (applet, applet.isActivated) }
                }
                return await group.reduce(into: []) { array, result in
                    if result.1 {
                        array.append(result.0)
                    }
                }
            }
        }
    }
}
