//
//  ConnectPeripheralEntity.swift
//  qcc5100.sample
//
//

import Foundation
import CoreBluetooth

struct PeripheralEntity: Identifiable, Equatable {
    static func == (lhs: PeripheralEntity, rhs: PeripheralEntity) -> Bool {
        return lhs.uuid == rhs.uuid
    }
    
    var id: UUID {
        return self.uuid
    }
    var isPaired: Bool = false

    let name: String
    let uuid: UUID
    let advertisementData: [String : Any]?
    let rssi: Int?
    let rawInstance: CBPeripheral?
    
    var commandReceiverCharacteristic: CBCharacteristic? = nil
    var onBoardUserEventCharacteristic: CBCharacteristic? = nil
}

class BLEEntity: ObservableObject {
    @Published var foundPeripherals = [PeripheralEntity]()
    @Published var currentConnected: PeripheralEntity?
    @Published var phoneToWatchQue: CommandReceiverCommand? = nil {
        willSet {
            print("## phoneToWatchQue update to: \(newValue?.name ?? "nil")")
        }
    }
}
