//
//  OsPermissionEntity.swift
//  qcc5100.sample
//

import Foundation
import CoreLocation
import UserNotifications
import MediaPlayer

class PermissionEntity: ObservableObject, Equatable {
    @Published var location: CLAuthorizationStatus
    @Published var mediaLibrary: MPMediaLibraryAuthorizationStatus
    @Published var notification: UNAuthorizationStatus = .notDetermined

    static func == (lhs: PermissionEntity, rhs: PermissionEntity) -> Bool {
        return lhs.location == rhs.location && lhs.mediaLibrary == rhs.mediaLibrary && lhs.notification == rhs.notification
    }

    init() {
        _location = Published(initialValue: CLLocationManager().authorizationStatus)

        _mediaLibrary = Published(initialValue: MPMediaLibrary.authorizationStatus())

        UNUserNotificationCenter.current().getNotificationSettings { settings in
            DispatchQueue.main.async {
                self.notification = settings.authorizationStatus
            }
        }
    }
}
