//
//  ServicePieceCoreSample.swift
//  qcc5100.sample
//

import RiiiverSDK

@objc(ServicePieceCoreSample)
class ServicePieceCoreSample: NSObject, ERBlockExecutor {
    func enable(applet: RiiiverSDK.ERApplet) -> Bool {
        return true
    }
    
    func disable(applet: RiiiverSDK.ERApplet) {
        //
    }
    
    func execute(applet: RiiiverSDK.ERApplet,
                 blockName: RiiiverSDK.ERBlockName,
                 preferenceJson: Dictionary<String, Any>?,
                 inputJson: Dictionary<String, Any>?,
                 handler: RiiiverSDK.ERBlockDelegate
    ) {
        print("ServicePieceCoreSample input:\(inputJson ?? [:]), preference:\(preferenceJson ?? [:])")

        var outputJson: Dictionary<String, Any>  = [:]
        if let inputJson = inputJson {
            // inputとして受け取った情報をそのまま次のPieceへ渡す
            // Input value goes through to the next piece as an output as it is
            outputJson["serviceSampleInfo"] = inputJson["sampleInfo"]
        }

        handler.completed(outputJson: outputJson, error: nil)
    }
}
