//
//  RiiiverLoginInteractor.swift
//  qcc5100.sample
//

import Foundation

protocol LoginRiiiverUsecase: AnyObject {
    func getLoginUrl() async throws -> URL
    func verifyCode(of url: URL) async throws -> Void
}

final class LoginRiiiverInteractor {
    private var erAuthClient: ERAuthClientInterface
    
    init(erAuthClient: ERAuthClientInterface = RiiiverSDKClient.sharedInstance) {
        self.erAuthClient = erAuthClient
    }
}

extension LoginRiiiverInteractor: LoginRiiiverUsecase {
    func getLoginUrl() async throws -> URL {
        return try await self.erAuthClient.getLoginUrl()
    }
    
    func verifyCode(of url: URL) async throws -> Void {
        return try await self.erAuthClient.verifyCode(of: url)
    }
}
