//
//  DeviceSearchResultRouter.swift
//  qcc5100.sample
//

import SwiftUI

protocol DeviceSearchResultWireframe: AnyObject {
    func segueToSettings()
}

final class DeviceSearchResultRouter {
    private var appNavigatePath: AppNavigatePath
    
    private init() {
        self.appNavigatePath = AppNavigatePath.sharedInstance
    }
    
    static func assembleModules() -> DeviceSearchResultView {
        let viewDelegate = DeviceSearchResultViewDelegate()
        var view = DeviceSearchResultView(delegate: viewDelegate)
        let router = DeviceSearchResultRouter()
        let searchDeviceInteractor = SearchDeviceInteractor()
        let getAppInfoInteractor = GetAppInfoInteractor()
        let presenter = DeviceSearchResultPresenter(
            viewDelegate: viewDelegate,
            router: router,
            searchDeviceInteractor: searchDeviceInteractor,
            getAppInfoInteractor: getAppInfoInteractor
        )
        
        view.presenter = presenter
        
        return view
    }
}

extension DeviceSearchResultRouter: DeviceSearchResultWireframe {
    func segueToSettings() {
        appNavigatePath.push(to: .deviceSettings)
    }
}
