//
//  DeviceRow.swift
//  qcc5100.sample
//

import SwiftUI
import CoreBluetooth

struct PeripheralCell: View {
    let peripheral: PeripheralEntity
    let onTap: () -> Void
    
    init(peripheral: PeripheralEntity, onTap: @escaping () -> Void) {
        self.peripheral = peripheral
        self.onTap = onTap
    }
    
    var body: some View {
        HStack {
            Text(peripheral.name).padding()
            Spacer()
        }
        .contentShape(Rectangle())
        .onTapGesture {
            onTap()
        }
    }
}

struct PeripheralCell_Previews: PreviewProvider {
    private static let mockPeripheral = PeripheralEntity(name: "RIIIVER_DEVICE",
                                                         uuid: UUID(uuidString: "acde070d-8c4c-4f0d-9d8a-162843c10333")!,
                                                         advertisementData: ["hoge": "fuga"],
                                                         rssi: 21,
                                                         rawInstance: nil)

    static var previews: some View {
        PeripheralCell(peripheral: mockPeripheral) {
            print("onTap")
        }
    }
}
