//
//  ScanFloatingButton.swift
//  qcc5100.sample
//

import SwiftUI

struct ScanFloatingButton: View {
    let onTap: (() -> Void)

    var body: some View {
        VStack {
            Spacer()
            HStack {
                Spacer()
                Button(
                    action: onTap,
                    label: {
                        Image(systemName: "magnifyingglass.circle")
                            .foregroundColor(.white)
                            .font(.system(size: 18))
                        Text("Scan")
                            .foregroundColor(.white)
                            .font(.system(size: 18))
                    }
                )
                    .frame(width: 144, height: 40)
                    .background(Color.blue)
                    .cornerRadius(8.0)
                    .shadow(color: .gray, radius: 3, x: 3, y: 3)
                    .padding(EdgeInsets(top: 0, leading: 0, bottom: 32.0, trailing: 32.0))
            }
        }
    }
}
