//
//  DeviceSettingsRouter.swift
//  qcc5100.sample
//

import Foundation

protocol DeviceSettingsWireframe: AnyObject {
    func popToSearchDevice()
    func segueToIiideaList()
}

final class DeviceSettingsRouter {
    private var appNavigatePath: AppNavigatePath
    
    private init() {
        self.appNavigatePath = AppNavigatePath.sharedInstance
    }
    
    static func assembleModules() -> DeviceSettingsView {
        let viewDelegate = DeviceSettingsViewDelegate()
        var view = DeviceSettingsView(delegate: viewDelegate)
        let router = DeviceSettingsRouter()
        let searchDeviceInteractor = SearchDeviceInteractor()
        let manageIiideainteractor = ManageIiideaInteractor()
        let presenter = DeviceSettingsPresenter(
            viewDelegate: viewDelegate,
            router: router,
            searchDeviceInteractor: searchDeviceInteractor,
            manageIiideaInteractor: manageIiideainteractor)
        
        view.presenter = presenter
        
        return view
    }
}

extension DeviceSettingsRouter: DeviceSettingsWireframe {
    func popToSearchDevice() {
        appNavigatePath.pop()
    }
    
    func segueToIiideaList() {
        appNavigatePath.push(to: .userWebView)
    }
}
