//
//  RiiiverLoginRouter.swift
//  qcc5100.sample
//

import SwiftUI

protocol RiiiverLoginWireFrame: AnyObject {
    func pop()
    func popToDeviceSettings()
}

final class RiiiverLoginRouter {
    private var appNavigatePath: AppNavigatePath
    
    private init() {
        self.appNavigatePath = AppNavigatePath.sharedInstance
    }
    
    static func assembleModules() -> RiiiverLoginView {
        let viewDelegate = RiiiverLoginViewDelegate()
        var view = RiiiverLoginView(delegate: viewDelegate)
        let router = RiiiverLoginRouter()
        let interactor = LoginRiiiverInteractor()
        let presenter = RiiiverLoginPresenter(viewDelegate: viewDelegate,
                                              router: router,
                                              interactor: interactor)
        
        view.presenter = presenter
        
        return view
    }
}

extension RiiiverLoginRouter: RiiiverLoginWireFrame {
    func pop() {
        print("pop to prefer view")
        appNavigatePath.pop()
    }
    
    func popToDeviceSettings() {
        appNavigatePath.popTo(.deviceSettings)
    }    
}
