//
//  RootView.swift
//  qcc5100.sample
//

import SwiftUI

struct RootView: View {
    @ObservedObject var navigatePath: AppNavigatePath
    
    init() {
        navigatePath = AppNavigatePath.sharedInstance
    }

    var body: some View {
        VStack {
            switch navigatePath.current {
            case .riiiverLogin:
                RiiiverLoginRouter.assembleModules()
            case .userWebView:
                UserWebViewRouter.assembleModules()
            case .deviceSearch:
                DeviceSearchResultRouter.assembleModules()
            case .deviceSettings:
                DeviceSettingsRouter.assembleModules()
            }
        }
    }
}
