//
//  ProfileRouter.swift
//  qcc5100.sample
//

import Foundation

protocol UserWebViewWireframe: AnyObject {
    func segueLoginView()
    func popToMyIiidea()
}

final class UserWebViewRouter {
    private var appNavigatePath: AppNavigatePath
    
    private init() {
        self.appNavigatePath = AppNavigatePath.sharedInstance
    }
    
    static func assembleModules() -> UserWebView {
        let viewDelegate = UserWebViewDelegate()
        let subViewDelegate = UserWebViewWrapperDelegate()
        var view = UserWebView(viewDelegate: viewDelegate, subViewDelegate: subViewDelegate)
        let router = UserWebViewRouter()
        let interactor = ManageIiideaInteractor()
        let requestPermissionInteractor = RequestPermissionInteractor()
        let presenter = UserWebViewPresenter(viewDelegate: viewDelegate,
                                             subViewDelegate: subViewDelegate,
                                             router: router,
                                             interactor: interactor,
                                             requestPermissionInteractor: requestPermissionInteractor)
        
        view.presenter = presenter
        
        return view
    }
}

extension UserWebViewRouter: UserWebViewWireframe {
    func segueLoginView() {
        appNavigatePath.push(to: .riiiverLogin)
    }
    
    func popToMyIiidea() {
        appNavigatePath.pop()
    }
}
