//
//  SFSafariView+QCC5100.swift
//  qcc5100.sample
//

import SwiftUI
import SafariServices

struct SafariView: UIViewControllerRepresentable {
    typealias Configuration = SFSafariViewController.Configuration
    
    private let url: URL
    private let config: Configuration?
    
    
    init(url: URL, config: Configuration? = nil) {
        self.url = url
        self.config = config
    }

    func makeUIViewController(context: Context) -> SFSafariViewController {
        let safariVC: SFSafariViewController
        if let config {
            safariVC = SFSafariViewController(url: url, configuration: config)
        } else {
            safariVC = SFSafariViewController(url: url)
        }
        return safariVC
    }
    
    func updateUIViewController(_ uiViewController: SFSafariViewController, context: Context) {
    }
}
